 import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { select, axisLeft, axisBottom, csv, arc, pie, scaleBand, scaleLinear, max, format} from 'd3';<script src="https://d3js.org/d3.v4.min.js"></script>


    var svg = d3.select("svg"),
        margin = 200,
        width = svg.attr("width") - margin,
        height = svg.attr("height") - margin;

    svg.append("text")
       .attr("transform", "translate(100,0)")
       .attr("x", 50)
       .attr("y", 50)
       .attr("font-size", "30px")
       .attr("stroke", "white")
       .text("OTT PLATFORM")

    var x = d3.scaleBand().range([0, width]).padding(0.4),
        y = d3.scaleLinear().range([height, 0]);

    var g = svg.append("g")
            .attr("transform", "translate(" + 100 + "," + 100 + ")");

    d3.csv("https://gist.githubusercontent.com/Saahithi49/cacc795c51f2e915a0e30e904ba4a3c5/raw/4656a3aabfca92f2a25e90e1de9c77405f912a55/ott.csv", function(error, data) {
        if (error) {
            throw error;
        }

        x.domain(data.map(function(d) { return d.Platform; }));
        y.domain([0, d3.max(data, function(d) { return d.Movies; })]);
      
     

        g.append("g")
         
         .attr("transform", "translate(0," + height + ")")
         .call(d3.axisBottom(x))
             
         .append("text")
         .attr("y", height - 250)
         .attr("x", width - 100)
         .attr("text-anchor", "end")
         .attr("stroke", "white")
         .text("Platform");
    
        g.append("g")
         .call(d3.axisLeft(y).tickFormat(function(d){
             return  + d;
         }).ticks(10))
         .append("text")
         .attr("transform", "rotate(-90)")
         .attr("y", 8)
         .attr("dy", "-7.1em")
         .attr("text-anchor", "end")
         .attr("stroke", "white")
         .text("Number Of Movies");
      
     

        g.selectAll(".bar")
         .data(data)
         .enter().append("rect")
         .attr("class", "bar")
         .on("mouseover", onMouseOver) //Add listener for the mouseover event
         .on("mouseout", onMouseOut)   //Add listener for the mouseout event
         .attr("x", function(d) { return x(d.Platform); })
         .attr("y", function(d) { return y(d.Movies); })
         .attr("width", x.bandwidth())
         .transition()
         .ease(d3.easeLinear)
         .duration(400)
         .delay(function (d, i) {
             return i * 50;
         })
         .attr("height", function(d) { return height - y(d.Movies); });
    });
    
    //mouseover event handler function
    function onMouseOver(d, i) {
        d3.select(this).attr('opacity', '0.5');
        d3.select(this)
          .transition()     // adds animation
          .duration(400)
          .attr('width', x.bandwidth() + 5)
          .attr("y", function(d) { return y(d.Movies) - 10; })
          .attr("height", function(d) { return height - y(d.Movies) + 10; });

        g.append("text")
         .attr('class', 'val') 
         .attr('x', function() {
             return x(d.Platform);
         })
         .attr('y', function() {
             return y(d.Movies) - 15;
         })
         .text(function() {
             return [+d.Movies];  // Value of the text
         });
    }

    //mouseout event handler function
    function onMouseOut(d, i) {
        // use the text label class to remove label on mouseout
        d3.select(this).attr('opacity', '1');
        d3.select(this)
          .transition()     // adds animation
          .duration(400)
          .attr('width', x.bandwidth())
          .attr("y", function(d) { return y(d.Movies); })
          .attr("height", function(d) { return height - y(d.Movies); });

        d3.selectAll('.val')
          .remove()
    }

